from codecs import encode
import os
import requests
import time
from pathlib import Path
import pandas as pd

configs={
    # 'nlp_qwen2.5-7b':{
    #     'API_URL':"http://10.11.37.6:13206/member1/llm-inferservice-910b-qwen25-7b/v1/chat/completions",
    #     'MODEL':"qwen2.5-7b",
    #     'MAX_TOKENS':8192,
    #     'API_KEY':"96f2429b19e6ab6d3b6a030ef0e77e9dcd105878"
    # },
    # 'nlp-175b':{
    #     'API_URL':"http://10.11.37.6:13206/member1/nlp-http/v1/chat/completions",
    #     'MODEL':"nlp175b",
    #     'MAX_TOKENS':12800,
    #     'API_KEY':"02909c833c8756dfc5b86ec73c8b9cb804278536"
    # },
    'silcon-qwen2.5-7b':{
        'API_URL':"https://api.siliconflow.cn/v1/chat/completions",
        'MODEL':"Qwen/Qwen2.5-7B-Instruct",
        'MAX_TOKENS':4096,
        'API_KEY':"sk-ndfabmsjblfrtxggizxnorbmsodxdrrnhhisyiadhscbjvkd"
    },
    'glm-9b':{
        'API_URL':"https://open.bigmodel.cn/api/paas/v4/chat/completions",
        'MODEL':"glm-4-flash",
        'MAX_TOKENS':4096,
        'API_KEY':"3056ef0b0ef90942ff92f27e38931655.Qrxv6J18D7nFdZfc"
    },

}



def list_txt_files(folder_path):
    """列出所有不以'_en.txt'结尾的文本文件"""
    return [f for f in Path(folder_path).glob("*.txt") if not f.name.endswith("_en.txt")]

def read_file(file_path):
    """读取文本文件内容，并按段落拆分"""
    with open(file_path, 'r', encoding='utf-8') as f:
        return f.read().strip()

def add_file(_path:str, text:str):
    """保存翻译后的文本到新文件"""
    with open(_path, 'a', encoding='utf-8') as f:
        f.write(text)



def if_sex(source_text:str,modelname):
    translation_prompt = f"""请判断以下内容是否有男女情色关系的描写，并给出情色级别（0-9分）。完全不涉及男女关系为0，有对于女人美貌的描写1-2,如有男女同处一室暧昧的气氛或身体接触2-3,如有搂抱、拥抱、性感词、性暗示等3-5，抚摸、亲吻等推进关系升级4-6，脱衣、裸体5-7，如果有性行为的描写则为7-9分。先分析原因，并最后给综合评价情色级别。
# 文章内容:
{source_text}
# 输出格式要求,只要分析和情色级别两部分内容就可以，不要其他内容：
分析：只需要最简单一句话，来说明原因，特别是情色描述的类型，如果没有则输出“无情色描写”。
情色级别：只需要一个数字，不要其他内容。
# 输出格式参考：
分析：文章中涉及了林妃萱对苏麟身体接触的描写，如“苏麟趁机一个翻身，骑在了她的腰上”，暗示了较为强烈的紧张和性暗示的情绪氛围，甚至是强烈的引导信号，建议给出的情色级别为4分。
情色级别：4

    """
    system_message='你是一个文章审核大师，能很好分辨文章中判断文章进行审核和分类。'
    translation=''
    while translation=="":
        translation = get_completion(translation_prompt,system_message, configs[modelname])
        time.sleep(1)
    return translation



def get_completion(prompt:str, system_message:str, model):
    api_url = model['API_URL']
    modelname = model['MODEL']
    max_tokens = model['MAX_TOKENS']
    api_key = model['API_KEY']
    headers = {"Authorization": f"Bearer {api_key}"}
    payload = {
        "model": modelname,
        "max_tokens": max_tokens,
        "messages": [{"role": "system", "content": system_message},{"role": "user", "content": prompt}],
        "stream": False  # 启用流式响应
    }

    try:
        response = requests.post(api_url, json=payload, headers=headers, timeout=30)
        if 'choices' in response.json().keys():
            content=response.json()["choices"][0]["message"]["content"]
            return content
        else:
            return ""

    except requests.RequestException as e:
        print(f"失败: {e}")
        return ""  # 失败时返回空字符串

if not os.path.exists("judge_sex.csv"):
    with open("judge_sex.csv", "w", encoding="utf-8-sig") as f:
        f.write("文件名,分析,情色级别\n")

if __name__ == "__main__":
    folder_path = "./10001410"  # 指定要处理的文件夹

    datas=pd.read_csv("judge_sex.csv",encoding="utf-8-sig")
    file_list =datas['文件名'].tolist()
    datas=datas.to_dict('records')
    txt_files = list_txt_files(folder_path)
    for file_path_ in txt_files[:]:
        if file_path_.name in file_list:
            continue

        article_content = read_file(file_path_)
        new_path = str(file_path_).replace(".txt", "_en.txt")
        try:
            translated_text = if_sex(article_content,'silcon-qwen2.5-7b')
            if len(translated_text)>0:
                print(translated_text)
                reason,level=translated_text.split("情色级别：")
                datas.append({"文件名":file_path_.name,"分析":reason,"情色级别":level})
        except:
            print("失败")
    df=pd.DataFrame(datas)
    df.to_csv("judge_sex.csv",index=False,encoding="utf-8-sig")
    print("所有文件处理完毕！")

